Seuls les membres ayant 30 points peuvent parler sur le chat.

Forum Casio - Projets de programmation


Index du Forum » Projets de programmation » fxSDK, un SDK alternatif pour écrire des add-ins
Lephenixnoir Hors ligne Administrateur Points: 18119 Défis: 142 Message

fxSDK, un SDK alternatif pour écrire des add-ins

Posté le 29/08/2014 22:00

Le fxSDK est une alternative au SDK habituel de Casio. Il permet de développer des add-ins pour la famille de la Graph 35+E et la Graph 90+E, et offre de meilleures performances et plus de possibilités !

Les outils du fxSDK

Le fxSDK marche sous Linux et a été compilé pour Mac OS ; il ne marche pas encore pour Windows mais on peut en discuter.

Il se fonde sur l'indispensable compilateur gcc et sa suite d'outils : as, ld, objdump, objcopy (entre autres). Contrairement au vieux compilateur du SDK, gcc est un compilateur moderne avec beaucoup de possibilités. Il n'est pas fourni avec le fxSDK et fait l'objet d'un tutoriel d'installation à part.

Côté calculatrice, c'est le noyau gint qui fait le travail. Il remplace fxlib et une partie de l'OS pour vous offrir des fonctionnalités plus cool et plus rapides. Les add-ins développés avec le fxSDK utilisent gint toutes les trois lignes !

Le fxSDK fournit également des outils spécifiques pour compiler et étudier les programmes de la calculatrice.

fxsdk est un petit gestionnaire de projet qui vous permet de créer et compiler facilement des projets sans vous prendre la tête avec le Makefile. Parfait si vous ne voulez pas connaître toutes les détails compliqués.

fxg1a sert à créer les fichiers g1a finaux à partir du programme compilé. C'est le successeur de mon vieux g1a-wrapper qui était beaucoup moins puissant.

fxconv convertit des données pour vos add-ins, commes vos images ou polices, dans des formats spécifiques de gint. C'est un peu comme le Sprite Coder mais ça vous évite de copier des gros tableaux dans votre programme et surtout le dessin est beaucoup plus performant !

fxos est un désassembleur et manipulateur d'OS capable de retrouver et disséquer des syscalls en un tour de poignet. C'est un outil de reverse-engineering dont l'usage principal est de produire des listings assembleur annotés pour comprendre très rapidement le code.

Il y a pas mal de différences avec le SDK de Casio donc passer au fxSDK nécessite un peu d'adaptation.

Installer le fxSDK sur votre ordinateur

Ça se passe en trois étapes :

1. Compiler un compilateur gcc à destination de la calculatrice
2. Installer le fxSDK
3. Installer le noyau, gint

Je suppose ici que vous connaissez les bases de la ligne de commande, mais si ce n'est pas le cas, n'hésitez pas à laisser un commentaire pour demander.

La première chose est de vous préparer un cross-compilateur gcc. Vous pouvez sauter l'installation du g1a-wrapper et venir ici dès que la libgcc est installée. Assurez-vous que le compilateur est dans le PATH est vous serez prêt ! C'est le plus gros morceau donc une fois que vous aurez ça, vous aurez déjà pratiquement fini.

Clônez le dépôt git du fxSDK depuis la forge de Planète Casio (vous pouvez aussi utiliser SSH).

% git clone 'https://gitea.planet-casio.com/Lephenixnoir/fxsdk.git'

Configurez le fxSDK ; vous pouvez taper "./configure --help" voir les options disponibles. Par défaut, le fxSDK sera installé dans votre dossier personnel (dans ".local").

% cd fxsdk
% ./configure

Ensuite compilez et installez ! Si vous avez choisi un dossier d'installation différent avec --prefix ou si vous compilez sous Mac, vous pourriez avoir besoin de sudo à l'installation.

% make
% make install

Assurez-vous que votre dossier de destination est dans votre PATH, puis vous pouvez installer gint.

Vous êtes alors prêt à partir !

Développer des programmes avec le fxSDK

TODO: Ajouter l'utilisation de fxsdk.

Toute la partie programmation revient à développer des programmes avec gint. Les tutoriels d'utilisation de gint couvrent tous ce dont vous aurez besoin, y compris l'utilisation de fxconv.


Fichier joint


Précédente 1, 2, 3 ··· 10 ··· 20, 21, 22, 23, 24, 25, 26 Suivante
Milang En ligne Membre Points: 473 Défis: 2 Message

Citer : Posté le 26/11/2019 18:57 | #


Je rencontre un problème étrange lorsque je tente de compiler une police
$ fxsdk build-fx

:: Making into build-fx

make: ***  Aucune règle pour fabriquer la cible « build-fx/assets/font/mario.png.o », nécessaire pour « SuperCbr.g1a ». Arrêt.

Pourtant, j'ai bien le dernier makefile (obtenu avec fxsdk update)
Où est le problème ?
Lephenixnoir Hors ligne Administrateur Points: 18119 Défis: 142 Message

Citer : Posté le 26/11/2019 19:01 | #


Le fxSDK reconnaît les polices placées dans assets-*/fonts.
Milang En ligne Membre Points: 473 Défis: 2 Message

Citer : Posté le 26/11/2019 19:05 | #


Oh non...
Je m'étais déjà fait avoir une fois, cette fois ci j'ai douté et refait la même xD
Lephenixnoir Hors ligne Administrateur Points: 18119 Défis: 142 Message

Citer : Posté le 26/11/2019 19:06 | #


Je devrais créer ces dossiers par défaut pour éviter les risques de confusion.
Milang En ligne Membre Points: 473 Défis: 2 Message

Citer : Posté le 10/12/2019 11:41 | #


J'ai le problème suivant lorsque je compile le projet :
$ fxsdk send

:: Installing for fx9860g using p7

fxconv -i assets-fx/img/mariobig.png -o build-fx/assets/img/mariobig.png.o --fx --toolchain=sh-elf name:img_mariobig
Traceback (most recent call last):
  File "/home/gmilan/.local/bin/fxconv", line 6, in <module>
    import fxconv
  File "/home/gmilan/.local/bin/fxconv.py", line 9, in <module>
    from PIL import Image
ModuleNotFoundError: No module named 'PIL'
make: *** [Makefile:139: build-fx/assets/img/mariobig.png.o] Error 1

L'image suivante est : donc probablement en mono_alpha puisqu'il y a de la transparence (on ne le voit pas forcément ici)
J'ai trouvé un bug ?
Milang En ligne Membre Points: 473 Défis: 2 Message

Citer : Posté le 10/12/2019 11:44 | # | Fichier joint


L'image est simplement exportée avec gimp en .png, avec les paramètres par défaut.
Yatis Hors ligne Membre Points: 512 Défis: 0 Message

Citer : Posté le 10/12/2019 11:59 | #


ModuleNotFoundError: No module named 'PIL'

Le problème vient d'un module manquant (PIL) je te laisse voir avec pip comment l'installer
https://stackoverflow.com/questions/20060096/installing-pil-with-pip
Lephenixnoir Hors ligne Administrateur Points: 18119 Défis: 142 Message

Citer : Posté le 10/12/2019 12:40 | #


Milang a écrit :
J'ai trouvé un bug ?

Pas encore, mais bien tenté.
Milang En ligne Membre Points: 473 Défis: 2 Message

Citer : Posté le 10/12/2019 16:18 | #


Et comment dois-je faire pour l'installer ?
J'utilise Manjaro Linux, et pacman me dit que le paquet python-pillow est installé. en plus j'ai essayé pip install Pillow et pip install pip, mais les deux commandes me retournent une erreur...
J'ai aussi réessayé d'installer python et le fxsdk mais cela ne change rien

Qu'est-ce que je dois faire ?
Lephenixnoir Hors ligne Administrateur Points: 18119 Défis: 142 Message

Citer : Posté le 10/12/2019 16:19 | #


J'ai bien python-pillow 6.2.1-1 qui me fournit le import PIL. Ça marche quand tu es dans un shell Python ?
Milang En ligne Membre Points: 473 Défis: 2 Message

Citer : Posté le 10/12/2019 16:22 | #


Non, import pillow et import pil ne marchent pas
Lephenixnoir Hors ligne Administrateur Points: 18119 Défis: 142 Message

Citer : Posté le 10/12/2019 16:29 | #


Est-ce que tu as bien un fichier /usr/lib/python3.8/site-packages/PIL/__init__.py ? Si oui, il faut que tu vérifies ton PATH Python.
Dark storm Hors ligne Membre d'honneur Points: 11088 Défis: 176 Message

Citer : Posté le 10/12/2019 16:52 | #


C'est quoi ta version de Python ? Sur les distro out-of-date by design (Debian et cie entre autres), c'est Python 2. Sauf qu'en 2019 on utilise la 3
Finir est souvent bien plus difficile que commencer. — Jack Beauregard
Milang En ligne Membre Points: 473 Défis: 2 Message

Citer : Posté le 10/12/2019 18:14 | #


@Darks Oui, je sais, j'ai la 3.8

Par contre non, je n'ai pas de fichier /usr/lib/python3.8/site-packages/PIL/__init__.py, car je n'ai tout simplement pas de dossier /usr/lib/python3.8/site-packages/PIL/
Mais la commande pip install PIL ou même pip3 install PIL ne marche pas plus pour autant
Lephenixnoir Hors ligne Administrateur Points: 18119 Défis: 142 Message

Citer : Posté le 10/12/2019 18:23 | #


Est-ce que tu as regardé quelle version de python-pillow tu as et où il est installé ?
Milang En ligne Membre Points: 473 Défis: 2 Message

Citer : Posté le 10/12/2019 18:40 | #


sudo pip install Pillow
Traceback (most recent call last):
  File "/usr/bin/pip", line 11, in <module>
    load_entry_point('pip==19.2.3', 'console_scripts', 'pip')()
  File "/usr/lib/python3.8/site-packages/pkg_resources/__init__.py", line 489, in load_entry_point
    return get_distribution(dist).load_entry_point(group, name)
  File "/usr/lib/python3.8/site-packages/pkg_resources/__init__.py", line 2852, in load_entry_point
    return ep.load()
  File "/usr/lib/python3.8/site-packages/pkg_resources/__init__.py", line 2443, in load
    return self.resolve()
  File "/usr/lib/python3.8/site-packages/pkg_resources/__init__.py", line 2449, in resolve
    module = __import__(self.module_name, fromlist=['__name__'], level=0)
  File "/usr/lib/python3.8/site-packages/pip/_internal/__init__.py", line 40, in <module>
    from pip._internal.cli.autocompletion import autocomplete
  File "/usr/lib/python3.8/site-packages/pip/_internal/cli/autocompletion.py", line 8, in <module>
    from pip._internal.cli.main_parser import create_main_parser
  File "/usr/lib/python3.8/site-packages/pip/_internal/cli/main_parser.py", line 7, in <module>
    from pip._internal.cli import cmdoptions
  File "/usr/lib/python3.8/site-packages/pip/_internal/cli/cmdoptions.py", line 29, in <module>
    from pip._internal.utils.ui import BAR_TYPES
  File "/usr/lib/python3.8/site-packages/pip/_internal/utils/ui.py", line 11, in <module>
    from pip._vendor.progress import HIDE_CURSOR, SHOW_CURSOR
ModuleNotFoundError: No module named 'pip._vendor.progress'


Pour ce qui est de python-pillow j'ai la version 6.2.0-1 ce qui doit être la derniere version
Lephenixnoir Hors ligne Administrateur Points: 18119 Défis: 142 Message

Citer : Posté le 10/12/2019 18:44 | #


Concentre-toi sur une des deux méthodes : ou bien PIP, ou bien pacman.
Youstones Hors ligne Membre Points: 332 Défis: 0 Message

Citer : Posté le 10/12/2019 18:46 | #


Mtn il est sur Windows ?
Mon cerveau se répète tous les jours la mythique phrase : "Houston, je crois que nous avons un problème"
Lephenixnoir Hors ligne Administrateur Points: 18119 Défis: 142 Message

Citer : Posté le 10/12/2019 18:47 | #


Youstones a écrit :
Mtn il est sur Windows ?

PIL oui, tout ce qui est Python est bien compatible en général.

Le fxSDK non. C'est portable, mais il faudrait un certain effort.
Milang En ligne Membre Points: 473 Défis: 2 Message

Citer : Posté le 10/12/2019 18:48 | #


Ah... le dossier PIL existe, mais dans le dossier /usr/lib/python3.7/site-packages/PIL/
Pourtant c'est bien python 3.8 qui est installé et le dossier python3.8 existe
Lephenixnoir Hors ligne Administrateur Points: 18119 Défis: 142 Message

Citer : Posté le 10/12/2019 18:53 | #


Ton paquet python-pillow ne doit pas être à jour.
Précédente 1, 2, 3 ··· 10 ··· 20, 21, 22, 23, 24, 25, 26 Suivante

LienAjouter une imageAjouter une vidéoAjouter un lien vers un profilAjouter du codeCiterAjouter un spoiler(texte affichable/masquable par un clic)Ajouter une barre de progressionItaliqueGrasSoulignéAfficher du texte barréCentréJustifiéPlus petitPlus grandPlus de smileys !
Cliquez pour épingler Cliquez pour détacher Cliquez pour fermer
Alignement de l'image: Redimensionnement de l'image (en pixel):
Afficher la liste des membres
Pour coloriser votre code, cliquez ici.
Sinon cliquez sur le bouton ci-dessous.
:bow: :cool: :good: :love: ^^
:omg: :fusil: :aie: :argh: :mdr:
:boulet2: :thx: :champ: :whistle: :bounce:
valider
 :)  ;)  :D  :p
 :lol:  8)  :(  :@
 0_0  :oops:  :grr:  :E
 :O  :sry:  :mmm:  :waza:
 :'(  :here:  ^^  >:)

Σ π θ ± α β γ δ Δ σ λ
Veuillez donner la réponse en chiffre
Vous devez activer le Javascript dans votre navigateur pour pouvoir valider ce formulaire.

Si vous n'avez pas volontairement désactivé cette fonctionnalité de votre navigateur, il s'agit probablement d'un bug : contactez l'équipe de Planète Casio.

Planète Casio v42 © créé par Neuronix et Muelsaco 2004 - 2020 | Il y a 82 connectés | Nous contacter | Qui sommes-nous ? | Licences et remerciements

Planète Casio est un site communautaire non affilié à Casio. Toute reproduction de Planète Casio, même partielle, est interdite.
Les programmes et autres publications présentes sur Planète Casio restent la propriété de leurs auteurs et peuvent être soumis à des licences ou copyrights.
CASIO est une marque déposée par CASIO Computer Co., Ltd